//SCRIPT BY BREBKAT youtube.com/@brebkat
//COPYRIGHT PIXLSTUDIOS 2023-2024
import * as server from '@minecraft/server'
import * as uimgr from '@minecraft/server-ui'
const world = server.world
const system = server.system
import { world, system, Player } from "@minecraft/server";
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";
function getChunkCoordinates(blockX, blockZ) {
    // Chunks are 16x16, so we divide the block coordinates by 16 and floor the result
    const chunkX = Math.floor(blockX / 16);
    const chunkZ = Math.floor(blockZ / 16);

    return { chunkX, chunkZ };
}
world.getAllPlayers().forEach(function (player) {
    console.warn(player.name)
})
world.beforeEvents.playerPlaceBlock.subscribe(data => {
    const chunkdata = getChunkCoordinates(data.block.x, data.block.z)
    //chunk plot id would look like "plot-77" for chunk 7,7
    const chunkowners = world.getDynamicProperty('plot-' + chunkdata.chunkX + chunkdata.chunkZ)
    const chunkownarr = JSON.parse(chunkowners)
    if (chunkownarr.includes(data.player.nameTag) || world.getDynamicProperty('plot-' + chunkdata.chunkX + chunkdata.chunkZ) == null) {
        //allow the block to be placed
    }
    else {
        //cancel the event result (block being placed)
        data.cancel = true
        //send the player a message
        data.player.sendMessage("ERROR: You dont own this chunk...")
    }
})
world.beforeEvents.playerBreakBlock.subscribe(data => {
    const chunkdata = getChunkCoordinates(data.block.x, data.block.z)
    //chunk plot id would look like "plot-77" for chunk 7,7
    const chunkowners = world.getDynamicProperty('plot-' + chunkdata.chunkX + chunkdata.chunkZ)
    const chunkownarr = JSON.parse(chunkowners)
    if (chunkownarr.includes(data.player.nameTag) || world.getDynamicProperty('plot-' + chunkdata.chunkX + chunkdata.chunkZ) == null) {
        //allow the block to be placed
    }
    else {
        //cancel the event result (block being placed)
        data.cancel = true
        //send the player a message
        data.player.sendMessage("ERROR: You dont own this chunk...")
    }
})
world.afterEvents.chatSend.subscribe(data => {
    const ply = data.sender
    const plypos = ply.location
    const msg = data.message
    if (msg == "!claim") {
        const plyx = plypos.x
        const plyz = plypos.z
        const chunk = getChunkCoordinates(plyx, plyz)
        if (world.getDynamicProperty('plot-' + chunk.chunkX + chunk.chunkZ) == null) {
            ply.sendMessage("Claiming plot...")
            const chunkdata = [ply.nameTag]
            const chunkdatastr = JSON.stringify(chunkdata)
            world.setDynamicProperty('plot-' + chunk.chunkX + chunk.chunkZ, chunkdatastr)
            ply.sendMessage("To add people to your claim, use the golden hoe that was just gaven to you!")
            ply.runCommandAsync("give @s golden_hoe")
        }
        else {
            ply.sendMessage("Chunk Already Claimed")
        }
    }
})
world.afterEvents.itemUse.subscribe(data => {
    //P
    const ply = data.source
    const plypos = ply.location
    if (data.itemStack.typeId == "minecraft:golden_hoe") {
        const plys = [...world.getAllPlayers()]
        const invfrm = new ModalFormData()
        const plyx = plypos.x
        const plyz = plypos.z
        //I
        const chunk = getChunkCoordinates(plyx, plyz)
        invfrm.title("Add People To Claim")
        invfrm.dropdown("Player To Give Plot Perms To", plys.map(ply => ply.nameTag))
        invfrm.show(ply).then(({ formValues: [dropdown] }) => {
            const inveplyobj = plys[dropdown]
            const inveply = inveplyobj.nameTag
            const ownarr = JSON.parse(world.getDynamicProperty('plot-' + chunk.chunkX + chunk.chunkZ))
            if (ownarr.includes(ply.nameTag)) {
                ownarr.push(inveply)
                world.setDynamicProperty('plot-' + chunk.chunkX + chunk.chunkZ, JSON.stringify(ownarr))
                ply.sendMessage('plot-' + chunk.chunkX + chunk.chunkZ)
                //X
                ply.sendMessage(JSON.stringify(ownarr))
            }
            else {
                ply.sendMessage("ERROR: No permission inside chunk")
            }
        })
    }
})
//L